#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: hasNoRelationDialog.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from PyQt4.QtCore import *
from PyQt4.QtGui import *
import sys,os

class hasNoRelationDialog(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		self.setWindowTitle(_(u'请设置当前音轨歌词策略'))
		MainWindowLayout=QVBoxLayout(None)
		
		layout1=QHBoxLayout(None)#
		layout1.setSpacing(50)
		layout1.setContentsMargins(10,10,10,10)
		self.label1=QLabel(self)
		self.label1.setText(_(u'当前音轨：'))
		self.trackLabel=QLabel(self)   #need to setText
		layout1.addWidget(self.label1)
		layout1.addWidget(self.trackLabel)
		
		layout2=QHBoxLayout(None)#
		layout2.setSpacing(50)
		layout2.setContentsMargins(10,10,10,10)
		self.label2=QLabel(self)
		self.label2.setText(_(u'当前策略：'))
		self.comboBox=QComboBox(self)
		a=[_(u'不使用策略'),_(u'不搜索本地'),_(u'不搜索网络'),_(u'什么都不做'),_(u'记住...')]
		for i in a:
			self.comboBox.insertItem(a.index(i),i)
		layout2.addWidget(self.label2)
		layout2.addWidget(self.comboBox)
		
		layout4=QHBoxLayout(None)
		self.pathLine=QLineEdit(self)
		self.pathLine.setReadOnly(True)
		self.pathLine.setEnabled(False)
		self.chooseButton=QPushButton(self)
		self.chooseButton.setText(_(u'选择...'))
		self.chooseButton.setEnabled(False)
		layout4.addWidget(self.pathLine)
		layout4.addWidget(self.chooseButton)
		
		layout3=QHBoxLayout(None)#
		layout3.setSpacing(70)
		layout3.setContentsMargins(10,10,10,10)
		self.okButton=QPushButton(self)
		self.okButton.setText(_(u'确定'))
		self.okButton.setEnabled(False)
		self.cancelButton=QPushButton(self)
		self.cancelButton.setText(_(u'取消'))
		layout3.addWidget(self.okButton)
		layout3.addWidget(self.cancelButton)
		
		MainWindowLayout.addLayout(layout1)
		MainWindowLayout.addLayout(layout2)
		MainWindowLayout.addLayout(layout4)
		MainWindowLayout.addLayout(layout3)
		
		self.setLayout(MainWindowLayout)
		
		self.connect(self.comboBox,SIGNAL("activated(int)"),self.changeStatus)
		self.connect(self.okButton,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancelButton,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.chooseButton,SIGNAL("clicked()"),self.chooseLrc)
	
	def chooseLrc(self):
		path=QFileDialog.getOpenFileName(self,_(u'请选择lrc文件'),os.getenv('HOME'),'*.lrc')
		if(path<>u''):
			self.pathLine.setText(path)
			self.okButton.setEnabled(True)
		
	def changeStatus(self,f):
		if(f==0):
			self.okButton.setEnabled(False)
			self.pathLine.setEnabled(False)
			self.chooseButton.setEnabled(False)
		elif(f==4):
			if(self.pathLine.text().isEmpty()):
				self.okButton.setEnabled(False)
			else:
				self.okButton.setEnabled(True)
			self.pathLine.setEnabled(True)
			self.chooseButton.setEnabled(True)
		else:
			self.okButton.setEnabled(True)
			self.pathLine.setEnabled(False)
			self.chooseButton.setEnabled(False)
