#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: gui.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

import chardet
from PyQt4.QtGui import *
from PyQt4.QtCore import *
import lrcParser,readConfig,s2t
from ttpClient import ttpClient
from addPathQt4 import addPathQt4
from locale import getdefaultlocale
from chooseItemQt4 import chooseItem
from helpBrowserQt4 import helpWindow
from ttpChooseGuiQt4 import ttpChooseGui
from otherSettingQt4 import otherSettingQt4
from hasRelationDialogQt4 import hasRelationDialog
from hasNoRelationDialogQt4 import hasNoRelationDialog
import sys,commands,glob,urllib,re,os,ConfigParser,random,pickle





class netThread(QThread):
	
	'''
	This class provide a network function for lrcShow-II, normally it connect to the search engine and analysis if the lrc we needed exists
	'''
	
	def __init__(self,receiver,url,proxy,engine):
		QThread.__init__(self)
		self.url=url
		self.receiver=receiver
		self.proxy=proxy
		self.engine=engine
	
	def run(self):
		if(self.engine=='baidu'):
			netEncoder='gb18030'
			try:
				file=urllib.urlopen(self.url,None,self.proxy)
				lrc_gb=file.read()
				file.close()
			except IOError:
				originalLrc=None
				timeOut=True
				self.sleep(1)
				ev=netEvent(originalLrc,timeOut,netEncoder)
				QApplication.postEvent(self.receiver,ev)
			else:
				tmp=unicode(lrc_gb,'gb18030').encode('utf8')
				tmpList=re.findall(r'【LRC】.*?<font size=-1>',tmp)
				if(len(tmpList)==0):
					originalLrc=None
					timeOut=False
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					QApplication.postEvent(self.receiver,ev)
				else:
					lrcList=self.baiduParser(tmpList)
					if(len(lrcList)==1):
						try:
							ff=urllib.urlopen(lrcList[0][0],None,self.proxy)
							originalLrc=ff.read()
							ff.close()
						except IOError:
							originalLrc=None
							timeOut=True
							self.sleep(1)
							ev=netEvent(originalLrc,timeOut,netEncoder)
							QApplication.postEvent(self.receiver,ev)
						else:
							timeOut=False
							if(not re.search('\[\d{2,}:\d{1,}.*?\]',originalLrc)):
								originalLrc=None
							self.sleep(1)
							ev=netEvent(originalLrc,timeOut,netEncoder)
							QApplication.postEvent(self.receiver,ev)
					else:
						self.sleep(1)
						ev=baiduEvent(lrcList)
						QApplication.postEvent(self.receiver,ev)

		elif(self.engine=='sogou'):
			netEncoder='gb18030'
			try:
				file=urllib.urlopen(self.url,None,self.proxy)
				lrc_gb=file.read()
				file.close()
			except IOError:
				originalLrc=None
				timeOut=True
				self.sleep(1)
				ev=netEvent(originalLrc,timeOut,netEncoder)
				QApplication.postEvent(self.receiver,ev)
			else:
				tmp=unicode(lrc_gb,'gb18030').encode('utf8')
				tmpList=tmpList=re.findall('href=\"downlrc\.jsp\?tGroupid=.*?\"',tmp)
				if(len(tmpList)<>0):
					lrcUrlPre=re.sub('href="|"','',tmpList[0])
					lrcUrl='http://mp3.sogou.com/'+lrcUrlPre
					try:
						ff=urllib.urlopen(lrcUrl,None,self.proxy)
						originalLrc=ff.read()
						ff.close()
					except IOError:
						originalLrc=None
						timeOut=True
						self.sleep(1)
						ev=netEvent(originalLrc,timeOut,netEncoder)
						QApplication.postEvent(self.receiver,ev)
					else:
						timeOut=False
						if(not re.search('\[\d{2,}:\d{1,}.*?\]',originalLrc)):
							originalLrc=None
						self.sleep(1)
						ev=netEvent(originalLrc,timeOut,netEncoder)
						QApplication.postEvent(self.receiver,ev)
				else:
					originalLrc=None
					timeOut=False
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					QApplication.postEvent(self.receiver,ev)
		elif(self.engine=='ttPlayer'):
			netEncoder='utf8'
			try:
				file=urllib.urlopen(self.url,None,self.proxy)
				webInfo=file.read()
				file.close()
			except IOError:
				originalLrc=None
				timeOut=True
				self.sleep(1)
				ev=netEvent(originalLrc,timeOut,netEncoder)
				QApplication.postEvent(self.receiver,ev)
			else:
				tmpList=re.findall(r'<lrc.*?</lrc>',webInfo)
				if(len(tmpList)==0):
					originalLrc=None
					timeOut=False
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					QApplication.postEvent(self.receiver,ev)
				else:
					lrcList=self.ttplayerParser(tmpList)
					if(len(lrcList)==1):
						url='http://lrcct2.ttplayer.com/dll/lyricsvr.dll?dl?Id=%d&Code=%d&uid=01&mac=%012x' %(int(lrcList[0][0]),ttpClient.CodeFunc(int(lrcList[0][0]),(lrcList[0][1]+lrcList[0][2])), random.randint(0,0xFFFFFFFFFFFF))
						try:
							ff=urllib.urlopen(url,None,self.proxy)
							originalLrc=ff.read()
							ff.close()
						except IOError:
							originalLrc=None
							timeOut=True
							self.sleep(1)
							ev=netEvent(originalLrc,timeOut,netEncoder)
							QApplication.postEvent(self.receiver,ev)
						else:
							timeOut=False
							if(not re.search('\[\d{2,}:\d{1,}.*?\]',originalLrc)):
								originalLrc=None
							self.sleep(1)
							ev=netEvent(originalLrc,timeOut,netEncoder)
							QApplication.postEvent(self.receiver,ev)
					else:
						self.sleep(1)
						ev=ttpEvent(lrcList)
						QApplication.postEvent(self.receiver,ev)
	
	def ttplayerParser(self,a):
		b=[]
		for i in a:
			c=re.findall('=\".*?\"',i)
			c=map(lambda x: re.sub('=|\"','',x),c)
			b.append(c)
		return b
	
	def baiduParser(self,a):
		b=[]
		for i in a:
			t=re.sub(r'【LRC】.*?href="|target="_blank"><font size="3">|<font color=#C60A00>|</font>|</a>|<br>|<font size=-1>','',i)
			c=t.split('" ')
			b.append(c)
		return b
			

class downloadFromBaidu(QThread):
	
	def __init__(self,receiver,url,proxy):
		QThread.__init__(self)
		self.receiver=receiver
		self.url=url
		self.proxy=proxy
	
	def run(self):
		try:
			file=urllib.urlopen(self.url,None,self.proxy)
			originalLrc=file.read()
			file.close()
		except IOError:
			originalLrc=None
			timeOut=True
			ev=netEvent(originalLrc,timeOut,'gb18030')
			QApplication.postEvent(self.receiver,ev)
		else:
			timeOut=False
			if(not re.search('\[\d{2,}:\d{1,}.*?\]',originalLrc)):
				originalLrc=None
			ev=netEvent(originalLrc,timeOut,'gb18030')
			QApplication.postEvent(self.receiver,ev)

class downloadFromTtp(QThread):

	'''
	This class provide a special network function for downloading specific lrc file on ttplayer's search engine
	'''
	
	def __init__(self,receiver,url,proxy):
		QThread.__init__(self)
		self.receiver=receiver
		self.url=url
		self.proxy=proxy
	
	def run(self):
		try:
			file=urllib.urlopen(self.url,None,self.proxy)
			originalLrc=file.read()
			file.close()
		except IOError:
			originalLrc=None
			timeOut=True
			ev=netEvent(originalLrc,timeOut,'utf8')
			QApplication.postEvent(self.receiver,ev)
		else:
			timeOut=False
			if(not re.search('\[\d{2,}:\d{1,}.*?\]',originalLrc)):
				originalLrc=None
			ev=netEvent(originalLrc,timeOut,'utf8')
			QApplication.postEvent(self.receiver,ev)
		

class myThread(QThread):
	
	'''
	This thread class provides the function to waiting for Amarok's signal, and when lrcShow-II first run, it would to decide the Amarok's status
	'''
	
	def __init__(self,receiver,app):
		QThread.__init__(self)
		self.receiver=receiver
		self.app=app

	def run(self):
		status=commands.getoutput('dcop amarok player status')
		if(status=='2'):#playing
			amarokStatus='playing'
		elif(status=='0'):#stop
			amarokStatus='stop'
		else:#pause
			amarokStatus='pause'
		amarokSignal='startup'
		ev=myEvent(amarokSignal,amarokStatus)
		self.app.postEvent(self.receiver,ev)
		while True:
			try:
				signal=sys.stdin.readline().strip()
				if(signal=='engineStateChange: paused'):
					amarokSignal='engineStateChange'
					amarokStatus='pause'
					ev=myEvent(amarokSignal,amarokStatus)
					self.app.postEvent(self.receiver,ev)
				elif(signal=='engineStateChange: playing'):
					amarokSignal='engineStateChange'
					amarokStatus='playing'
					self.sleep(1)#for a xine engine's bug
					ev=myEvent(amarokSignal,amarokStatus)
					self.app.postEvent(self.receiver,ev)
				elif(signal=='engineStateChange: empty'):
					amarokSignal='engineStateChange'
					amarokStatus='stop'
					ev=myEvent(amarokSignal,amarokStatus)
					self.app.postEvent(self.receiver,ev)
				elif(re.search('configure',signal)):
					os.system('dcop amarok playlist popupMessage "Please configurate the script via GUI\'s menu directly."')
			except:
					pass

class myEvent(QEvent):
	def __init__(self,amarokSignal,amarokStatus):
		QEvent.__init__(self,QEvent.Type(QEvent.User+1))
		self.amarokSignal=amarokSignal
		self.amarokStatus=amarokStatus

class netEvent(QEvent):
	def __init__(self,originalLrc,timeOut,netEncoder):
		QEvent.__init__(self,QEvent.Type(QEvent.User+2))
		self.originalLrc=originalLrc
		self.timeOut=timeOut
		self.netEncoder=netEncoder

class ttpEvent(QEvent):
	def __init__(self,alist):
		QEvent.__init__(self,QEvent.Type(QEvent.User+3))
		self.alist=alist

class baiduEvent(QEvent):
	def __init__(self,alist):
		QEvent.__init__(self,QEvent.Type(QEvent.User+4))
		self.alist=alist

class mainBox(QTextBrowser):
	
	'''main GUI'''
	
	def __init__(self,*args):
        	apply(QTextBrowser.__init__,(self,) + args)
		self.setAlignment(Qt.AlignCenter)
		self.setLineWrapMode(QTextEdit.NoWrap)
		self.showMode='normal'
		self.WFlags=self.windowFlags()
		p=readConfig.readConfig('lrcShow-II.conf')
		try:
			(tmpPath,self.ifDownload,self.lineNum,bc,fc,hc,self.fontType,self.fontSize,self.proxy,self.encoderToWrite,self.searchEngine,self.saveLrcPath,self.noLrc,self.includeCancel,self.autoInsertAmarok,self.titleBarInfo,self.completeTag)=p.parse()
		except:
			QMessageBox.critical(self,_(u'配置文件错误'),_(u'请删除原配置文件后再次启动脚本'))
			sys.exit()
		if(self.proxy=='no'):
			self.proxy=None
		else:
			self.proxy={'http':self.proxy}
		self.initMenu()
		if(self.ifDownload=='yes'):
			self.downloadMenu_yesAction.setIcon(QIcon('../scripts/lrcShow-II/icon/apply.png'))
		else:
			self.downloadMenu_noAction.setIcon(QIcon('../scripts/lrcShow-II/icon/apply.png'))
		self.downloadMenu_thisAction.setEnabled(False)
		self.initSettingMenuBar()
		a=bc.split(',')
		b=fc.split(',')
		c=hc.split(',')
		self.backGroundColor=QColor(int(a[0]),int(a[1]),int(a[2]))
		self.foreGroundColor=QColor(int(b[0]),int(b[1]),int(b[2]))
		self.highLightColor=QColor(int(c[0]),int(c[1]),int(c[2]))
		self.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
		self.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
		self.setAutoFillBackground(True)
		self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
		self.setMinimumHeight(200)
		self.setMinimumWidth(360)
		self.setFont(QFont(self.fontType,self.fontSize))
		self.setWindowIcon(QIcon('../scripts/lrcShow-II/icon/logo.png'))
		self.mytimer=QTimer()
		self.mytimer.setSingleShot(True)
		self.locale=getdefaultlocale()[1]
		self.path=tmpPath.split(',')
		self.path=map(lambda x:unicode(x,'utf8').encode(self.locale),self.path)[0:-1]
		self.saveLrcPath=unicode(self.saveLrcPath,'utf8').encode(self.locale)
		mydb=open('lrcShow-II.db','r')
		u=pickle.Unpickler(mydb)
		self.myData=u.load()
		mydb.close()

		self.connect(self.mytimer,SIGNAL("timeout()"),self.scrollContent)
		self.connect(self.lrcAdjustMenu_delayAction,SIGNAL("triggered()"),self.seekSlow)
		self.connect(self.lrcAdjustMenu_advancedAction,SIGNAL("triggered()"),self.seekFast)
		self.connect(self.lrcAdjustMenu_saveToFileAction,SIGNAL("triggered()"),self.saveToFile)
		self.connect(self.amarokControlMenu_playorpauseAction,SIGNAL("triggered()"),self.amarokControlMenu_playorpause)
		self.connect(self.amarokControlMenu_stopAction,SIGNAL("triggered()"),self.amarokControlMenu_stop)
		self.connect(self.amarokControlMenu_prevAction,SIGNAL("triggered()"),self.amarokControlMenu_prev)
		self.connect(self.amarokControlMenu_nextAction,SIGNAL("triggered()"),self.amarokControlMenu_next)
		self.connect(self.colorMenu_backAction,SIGNAL("triggered()"),self.colorMenu_back)
		self.connect(self.colorMenu_foreAction,SIGNAL("triggered()"),self.colorMenu_fore)
		self.connect(self.colorMenu_lightAction,SIGNAL("triggered()"),self.colorMenu_light)
		self.connect(self.colorMenu_defaultAction,SIGNAL("triggered()"),self.colorMenu_default)
		self.connect(self.setFontAction,SIGNAL("triggered()"),self.setFontAction_)
		self.connect(self.setLineAction,SIGNAL("triggered()"),self.setLineAction_)
		self.connect(self.setLocalPathAction,SIGNAL("triggered()"),self.setLocalPathAction_)
		self.connect(self.downloadMenu_yesAction,SIGNAL("triggered()"),self.downloadMenu_yesAction_)
		self.connect(self.downloadMenu_noAction,SIGNAL("triggered()"),self.downloadMenu_noAction_)
		self.connect(self.downloadMenu_thisAction,SIGNAL("triggered()"),self.downloadMenu_thisAction_)
		self.connect(self.displayMenu_normalAction,SIGNAL("triggered()"),self.displayMenu_normalAction_)
		self.connect(self.displayMenu_fullscreenAction,SIGNAL("triggered()"),self.displayMenu_fullscreenAction_)
		self.connect(self.displayMenu_osdAction,SIGNAL("triggered()"),self.displayMenu_osdAction_)
		self.connect(self.setProxyAction,SIGNAL("triggered()"),self.setProxyAction_)
		self.connect(self.openLrcEditorAction,SIGNAL("triggered()"),self.openLrcEditorAction_)
		self.connect(self.setSearchEngineAction,SIGNAL("triggered()"),self.setSearchEngineAction_)
		self.connect(self.otherFunctionsMenu_searchAction,SIGNAL("triggered()"),self.otherFunctionsMenu_searchAction_)
		self.connect(self.otherFunctionsMenu_reloadAction,SIGNAL("triggered()"),self.otherFunctionsMenu_reloadAction_)
		self.connect(self.otherFunctionsMenu_cancelAction,SIGNAL("triggered()"),self.otherFunctionsMenu_cancelAction_)
		self.connect(self.otherFunctionsMenu_insertAction,SIGNAL("triggered()"),self.otherFunctionsMenu_insertAction_)
		self.connect(self.otherFunctionsMenu_otherSetting,SIGNAL("triggered()"),self.otherFunctionsMenu_otherSetting_)
		self.connect(self.setStrategyAction,SIGNAL("triggered()"),self.setStrategyAction_)
		self.connect(self.setSaveEncoderAction,SIGNAL("triggered()"),self.setSaveEncoderAction_)
		self.connect(self.viewHelpAction,SIGNAL("triggered()"),self.viewHelpAction_)
		self.connect(self.aboutAction,SIGNAL("triggered()"),self.aboutAction_)
		self.connect(self.closeAction,SIGNAL("triggered()"),SLOT("close()"))
	
	def customEvent(self,ev):
		if(ev.type()==QEvent.User+1):
			self.amarokSignal=ev.amarokSignal
			self.amarokStatus=ev.amarokStatus
			if(self.mytimer.isActive()):
				self.mytimer.stop()
			try:
				self.downloadToLocalThread.terminate()
			except:
				pass
			try:
				self.downloadThread.terminate()
			except:
				pass
			try:
				self.chooseItermDialog1.done(-1)
			except:
				pass
			try:
				self.chooseItermDialog2.done(-1)
			except:
				pass
			try:
				self.relationDialog.done(-1)
			except:
				pass
			if(self.amarokStatus=='pause' and self.amarokSignal=='engineStateChange'):#$暂停
				self.amarokControlMenu_playorpauseAction.setText(_(u'播放'))
				self.amarokControlMenu_playorpauseAction.setIcon(QIcon('../scripts/lrcShow-II/icon/amarok_play.png'))
			if(self.amarokStatus=='playing' or (self.amarokStatus=='pause' and self.amarokSignal=='startup')):
				self.title=commands.getoutput('dcop amarok player title')
				self.artist=commands.getoutput('dcop amarok player artist')
				self.fileName=None
				self.originalLrc=None
				self.downloadMenu_thisAction.setEnabled(False)
				self.encoder=self.encoderToWrite
				
				if(self.titleBarInfo=='yes' and (self.artist<>'' or self.title<>'')):
					self.setWindowTitle('%s - %s' %(unicode(self.artist,self.locale),unicode(self.title,self.locale)))
				else:
					self.setWindowTitle(_(u'lrcShow-II'))
				if(self.amarokStatus=='pause' and self.amarokSignal=='startup'):
					self.amarokControlMenu_playorpauseAction.setText(_(u'播放'))
					self.amarokControlMenu_playorpauseAction.setIcon(QIcon('../scripts/lrcShow-II/icon/amarok_play.png'))
				else:
					self.amarokControlMenu_playorpauseAction.setText(_(u'暂停'))
					self.amarokControlMenu_playorpauseAction.setIcon(QIcon('../scripts/lrcShow-II/icon/amarok_pause.png'))
				self.amarokControlMenu_stopAction.setEnabled(True)
				self.otherFunctionsMenu_searchAction.setEnabled(True)
				self.setStrategyAction.setEnabled(True)
				if(self.title=='' and self.artist==''):
					self.showInfo('<p align="center">'+_(u'没有有效的标签信息')+'</p>')
				else:
					if(self.completeTag=='no'):
						self.checkData()
					else:
						if(self.title<>'' and self.artist<>''):
							self.checkData()
						else:
							self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II'+'</p>'))
			if(self.amarokStatus=='stop'):
				if(self.titleBarInfo=='yes'):
					self.setWindowTitle(_(u'lrcShow-II'))
				else:
					self.setWindowTitle(_(u'lrcShow-II'))
				self.amarokControlMenu_playorpauseAction.setText(_(u'播放'))
				self.amarokControlMenu_playorpauseAction.setIcon(QIcon('../scripts/lrcShow-II/icon/amarok_play.png'))
				self.amarokControlMenu_stopAction.setEnabled(False)
				self.otherFunctionsMenu_searchAction.setEnabled(False)
				self.setStrategyAction.setEnabled(False)
				self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II'+'</p>'),True)
					
		elif(ev.type()==QEvent.User+2):
			self.originalLrc=ev.originalLrc
			t=ev.timeOut
			self.netEncoder=ev.netEncoder
			if(self.originalLrc):
				self.initEvent(self.originalLrc,True)
			else:
				if(not t):
					self.showInfo('<p align="center">'+_(u'没有找到匹配的歌词')+'</p>')
				else:
					self.showInfo('<p align="center">'+_(u'网络连接超时')+'</p>')
					
		if(ev.type()==QEvent.User+3):
			lrcList=ev.alist
			self.chooseItermDialog1=ttpChooseGui(self)
			for j in lrcList:
				self.chooseItermDialog1.listBox.insertItem(lrcList.index(j),j[1].decode('utf8')+' - '+j[2].decode('utf8'))
			self.chooseItermDialog1.listBox.setCurrentRow(0)
			result1=self.chooseItermDialog1.exec_()
			if(result1==QDialog.Accepted):
				k=self.chooseItermDialog1.listBox.currentRow()
				url='http://lrcct2.ttplayer.com/dll/lyricsvr.dll?dl?Id=%d&Code=%d&uid=01&mac=%012x' %(int(lrcList[k][0]),ttpClient.CodeFunc(int(lrcList[k][0]),(lrcList[k][1]+lrcList[k][2])), random.randint(0,0xFFFFFFFFFFFF))
				self.downloadThreadFromTtp=downloadFromTtp(self,url,self.proxy)
				self.downloadThreadFromTtp.start()
			elif(result1==QDialog.Rejected):
				self.showInfo('<p align="center">'+_(u'没有找到匹配的歌词')+'</p>')

		if(ev.type()==QEvent.User+4):
			lrcList=ev.alist
			self.chooseItermDialog1=ttpChooseGui(self)
			for j in lrcList:
				self.chooseItermDialog1.listBox.insertItem(lrcList.index(j),j[1].decode('utf8'))
			self.chooseItermDialog1.listBox.setCurrentRow(0)
			result1=self.chooseItermDialog1.exec_()
			if(result1==QDialog.Accepted):
				k=self.chooseItermDialog1.listBox.currentRow()
				url=lrcList[k][0]
				self.downloadFromBaidu=downloadFromBaidu(self,url,self.proxy)
				self.downloadFromBaidu.start()
			elif(result1==QDialog.Rejected):
				self.showInfo('<p align="center">'+_(u'没有找到匹配的歌词')+'</p>')
	
	def showInfo(self,lf,ok=False):
		self.mainContents=lf
		self.initMainEvent()
		self.otherFunctionsMenu_cancelAction.setEnabled(False)
		self.otherFunctionsMenu_insertAction.setEnabled(False)
		self.lrcAdjustMenu_delayAction.setEnabled(False)
		self.lrcAdjustMenu_advancedAction.setEnabled(False)
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		if(ok):
			pass
		else:
			if(self.noLrc=='normal'):
				pass
			elif(self.noLrc=='hide'):
				self.hide()
			elif(self.noLrc=='mini'):
				self.showMinimized()
	
	def initEvent(self,lf,ask=False):
		if(self.noLrc=='hide' and self.isHidden()):
			if(self.showMode=='fullscreen'):
				self.show()
				self.showFullScreen()
			else:
				self.show()
		if(self.noLrc=='mini' and self.isMinimized()):
			if(self.showMode=='fullscreen'):
				self.showFullScreen()
			else:
				self.showNormal()
		self.seekTime=0
		self.totalSeekTime=0
		self.otherFunctionsMenu_cancelAction.setEnabled(True)
		self.otherFunctionsMenu_insertAction.setEnabled(True)
		self.lrcAdjustMenu_delayAction.setEnabled(True)
		self.lrcAdjustMenu_advancedAction.setEnabled(True)
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		
		self.openLrcEditorAction.setEnabled(True)
		if(self.ifDownload=='yes' and ask):
			try:
				unicode(lf,self.netEncoder).encode(self.encoderToWrite)
			except UnicodeEncodeError:
				QMessageBox.critical(self,_(u'编码错误'),_(u'在将搜索到的歌词（%s）编码为您预设的保存编码（%s）时发生错误，此次下载被忽略！\n这一般是由于搜索到的歌词中含有无法编码的字符造成的。\n如果多次出现本对话框，强烈建议您关闭自动下载功能，另外也可以设置保存编码为gb18030或者utf8以避免这个问题。') %(self.netEncoder,self.encoderToWrite))
			else:
				file=open(os.path.join(self.saveLrcPath,'%s - %s.lrc' %(self.artist,self.title)),'w')
				file.write(unicode(lf,self.netEncoder).encode(self.encoderToWrite))
				file.close()
				self.originalLrc=None
				
				
			
		if(self.ifDownload=='no' and ask):
			self.downloadMenu_thisAction.setEnabled(True)
		if(ask):
			a=unicode(lf,str(self.netEncoder))
			p=lrcParser.lrc(a)
			self.tag,self.mainContents=p.format()
			self.initMainEvent()
			self.goToCurrentPara()
		else:
			self.encoder=chardet.detect(lf)['encoding']
			if(self.encoder=='GB2312'):
				self.encoder='gb18030'
			try:
				a=unicode(lf,self.encoder)
			except UnicodeDecodeError:
				self.showInfo('<p align="center">'+_(u'读取本地歌词文件时出现编码错误'+'</p>'))
				self.openLrcEditorAction.setEnabled(False)
			else:
				p=lrcParser.lrc(a)
				self.tag,self.mainContents=p.format()
				self.initMainEvent()
				self.goToCurrentPara()
		if(self.autoInsertAmarok=='yes' and commands.getoutput('dcop amarok player lyrics')==''):
			self.otherFunctionsMenu_insertAction_()
	
	def initMainEvent(self):
		if(self.mytimer.isActive()):
				self.mytimer.stop()
		try:
			self.killTimer(self.timerId)
		except:
			pass
		j='<p align="center">&nbsp;</p>'*((self.lineNum-1)/2)
		self.lrcFile=j+self.mainContents+j+'<p align="center">&nbsp;</p>'
		self.lrcFile=re.sub(u'<br>',u'&nbsp;',self.lrcFile)
		self.setText(self.lrcFile)
		
		self.moveCursor(QTextCursor.Start)
		self.margin=QFontMetrics(self.font()).height()+12
		h=self.margin*self.lineNum
		self.hPos=0
		self.setFixedHeight(h)
	
	def goToCurrentPara(self):
		currentTime=int(commands.getoutput('dcop amarok player trackCurrentTimeMs'))
		try:
			p=-1
			while True:
				p+=1
				if(self.tag[p]>=currentTime):
					break
		except:
			for i in range(len(self.tag)+(self.lineNum-1)/2-1):
				self.moveCursor(QTextCursor.Down)
			self.hightLight()
			self.hPos=self.hPos+self.margin*len(self.tag)
			self.verticalScrollBar().setValue(self.hPos)
			
		else:
			for i in range(p+(self.lineNum-1)/2-1):
				self.moveCursor(QTextCursor.Down)
			self.num=p
			if(self.amarokStatus=='pause'):
				pass
			else:
				self.mytimer.start(self.tag[p]-currentTime)
			try:
				self.hPos=self.hPos+self.margin*(self.num-1)
				self.verticalScrollBar().setValue(self.hPos)
				if(self.lineNum<>1):
					self.hightLight()
			except:
				pass

	
	def hightLight(self):
		self.moveCursor(QTextCursor.StartOfLine)
        	self.moveCursor(QTextCursor.NextBlock,QTextCursor.KeepAnchor)
		
		
	
	def changeUrlToGb(self,info,locale):
		address=unicode(info,locale).encode('gb18030')
		return address

	def downLoad(self):
		if(self.searchEngine=='baidu'):
			url1='http://www.baidu.com/s?ie=gb2312&bs='
			url2='+filetype%3Alrc&sr=&z=&cl=3&f=8&wd='
			url3='+filetype%3Alrc&ct=0'
			url4_pre='%s %s' %(self.changeUrlToGb(self.title,self.locale),self.changeUrlToGb(self.artist,self.locale))
			url4=urllib.quote_plus(url4_pre)
			url=url1+url4+url2+url4+url3
			self.showInfo('<p align="center">'+_(u'正在从百度搜索...'+'</p>'),True)

		elif(self.searchEngine=='sogou'):
			url1='http://mp3.sogou.com/gecisearch.so?query='
			url2_pre='%s %s' %(self.changeUrlToGb(self.title,self.locale),self.changeUrlToGb(self.artist,self.locale))
			url2=urllib.quote_plus(url2_pre)
			url=url1+url2
			self.showInfo('<p align="center">'+_(u'正在从搜狐搜索...')+'</p>',True)
			
		elif(self.searchEngine=='ttPlayer'):
			url='http://lrcct2.ttplayer.com/dll/lyricsvr.dll?sh?Artist=%s&Title=%s&Flags=0' %(ttpClient.EncodeArtTit(unicode(self.artist,self.locale).replace(u' ','').lower()), ttpClient.EncodeArtTit(unicode(self.title,self.locale).replace(u' ','').lower()))
			self.showInfo('<p align="center">'+_(u'正在从ttPlayer歌词服务器搜索...')+'</p>',True)
			
		self.downloadThread=netThread(self,url,self.proxy,self.searchEngine)
		self.downloadThread.start()
	
	def checkData(self):
		data=self.myData.get('%s||%s' %(self.artist,self.title),False)
		if(data<>'FLAG.SKIP_ALL' and data<>'FLAG.SKIP_SEARCHLOCAL' and data<>'FLAG.SKIP_SEARCHENGINE' and data and os.path.exists(data)):
			self.fileName=data
			file=open(self.fileName)
			lf=file.read()
			file.close()
			self.initEvent(lf)
		elif(data<>'FLAG.SKIP_ALL' and data<>'FLAG.SKIP_SEARCHLOCAL' and data<>'FLAG.SKIP_SEARCHENGINE' and data and not os.path.exists(data)):
			del self.myData['%s||%s' %(self.artist,self.title)]
			mydb=open('lrcShow-II.db','w')
			pickler=pickle.Pickler(mydb,True)
			pickler.dump(self.myData)
			mydb.close()
			self.searchLocalLrc()
		elif(data=='FLAG.SKIP_SEARCHLOCAL'):
			self.downLoad()
		elif(data=='FLAG.SKIP_SEARCHENGINE'):
			self.searchLocalLrc(False)
		elif(data=='FLAG.SKIP_ALL'):
			self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
		else:
			self.searchLocalLrc()
			

	def searchLocalLrc(self,flag=True):
		if(len(self.path)<>0):
			k=[]
			for tmp in self.path:
				for lrcfile in glob.glob(os.path.join(tmp,'*.lrc')):
					if(self.title.lower() in lrcfile.lower() and self.artist.lower() in lrcfile.lower()):
						k.append(lrcfile)
			if(len(k)==0):
				if(flag==True):
					self.downLoad()
				else:
					self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
			elif(len(k)==1):
				self.fileName=k[0]
				file=open(self.fileName)
				lf=file.read()
				file.close()
				self.initEvent(lf)
			else:
				self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>',True)
				self.chooseItermDialog2=chooseItem(self)
				for i in k:
					self.chooseItermDialog2.listBox.insertItem(k.index(i),unicode(i,self.locale))
				self.chooseItermDialog2.listBox.setCurrentRow(0)
				result2=self.chooseItermDialog2.exec_()
				if(result2==QDialog.Accepted):
					self.fileName=k[self.chooseItermDialog2.listBox.currentRow()]
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData['%s||%s' %(self.artist,self.title)]=self.fileName
						mydb=open('lrcShow-II.db','w')
						pickler=pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					file=open(self.fileName)
					lf=file.read()
					file.close()
					self.initEvent(lf)
				elif(result2==QDialog.Rejected):
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData['%s||%s' %(self.artist,self.title)]='FLAG.SKIP_SEARCHLOCAL'
						mydb=open('lrcShow-II.db','w')
						pickler=pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					if(flag==True):
						self.downLoad()
					else:
						self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
				else:
					pass
		else:
			if(flag==True):
				self.downLoad()
			else:
				self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')

	def scrollContent(self):
		self.num+=1
		if(self.num<>len(self.tag)):
			if(self.tag[self.num]-self.tag[self.num-1]-self.seekTime<600):
				self.hPos=self.hPos+self.margin
				self.verticalScrollBar().setValue(self.hPos)
				if(self.lineNum<>1):
					#self.moveCursor(QTextCursor.Down)
					self.hightLight()
			else:
				self.terminal=self.hPos
				self.terminal=self.terminal+self.margin/5
				self.verticalScrollBar().setValue(self.terminal)
				self.timerId=self.startTimer(80)
			self.mytimer.start(self.tag[self.num]-self.tag[self.num-1]-self.seekTime)
			if(self.seekTime<>0):
				self.seekTime=0
		else:
			self.terminal=self.hPos
			self.terminal=self.terminal+self.margin/5
			self.verticalScrollBar().setValue(self.terminal)
			self.timerId=self.startTimer(80)
	
	def timerEvent(self,ev):
		if(ev.timerId()==self.timerId):
			self.terminal=self.terminal+self.margin/5
			if(self.terminal<self.hPos+self.margin):
				self.verticalScrollBar().setValue(self.terminal)
			else:
				self.hPos=self.hPos+self.margin
				self.verticalScrollBar().setValue(self.hPos)
				self.killTimer(self.timerId)
				if(self.lineNum<>1):
					#self.moveCursor(QTextCursor.Down)
					self.hightLight()

	##########  block:def lrcAdjustMenu's function  ##########
	
	def seekSlow(self):
		if(self.fileName):
			#self.childBox.saveButton.setEnabled(True)
			self.lrcAdjustMenu_saveToFileAction.setEnabled(True)
		self.seekTime=self.seekTime-200
		self.totalSeekTime=self.totalSeekTime-200
	
	def seekFast(self):
		if(self.fileName):
			#self.childBox.saveButton.setEnabled(True)
			self.lrcAdjustMenu_saveToFileAction.setEnabled(True)
		self.seekTime=self.seekTime+200
		self.totalSeekTime=self.totalSeekTime+200
	
	def saveToFile(self):
		file=open(self.fileName)
		content=unicode(file.read(),self.encoder).encode('utf8')
		file.close()
		offsetList=re.findall('\[offset:.*\]',content)
		if(len(offsetList)<>0):
			offsetOld=int(offsetList[0][8:-1])
			offsetNew=offsetOld+self.totalSeekTime
			offsetLine='[offset:%s]' %str(offsetNew)
			content=re.sub('\[offset:.*\]',offsetLine,content)
		else:
			offsetLine='[offset:%s]\n' %str(self.totalSeekTime)
			content=offsetLine+content
		content=unicode(content,'utf8').encode(self.encoderToWrite)
		file=open(self.fileName,'w')
		file.write(content)
		file.close()
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		self.totalSeekTime=0
		self.encoder=self.encoderToWrite
		
	##########  block end  ##########
	
	##########  block: def amarokControlMenu's function  ##########
	
	def amarokControlMenu_playorpause(self):
		if(self.amarokStatus=='stop' or self.amarokStatus=='pause'):
			os.system('dcop amarok player play')
		else:
			os.system('dcop amarok player pause')
			
	def amarokControlMenu_stop(self):
		os.system('dcop amarok player stop')
	
	def amarokControlMenu_prev(self):
		os.system('dcop amarok player prev')
		
	def amarokControlMenu_next(self):
		os.system('dcop amarok player next')
		
	##########  block end  ###########
	
	########## block: def colorMenu's function  ##########
	
	def colorMenu_back(self):
		rgbColor=QColorDialog.getColor(self.backGroundColor)
		if(rgbColor.isValid()):
			self.backGroundColor=rgbColor
			self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
			rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
			p=ConfigParser.ConfigParser()
			p.read('lrcShow-II.conf')
			p.set('option','backroundcolor',rgbString)
			p.write(open('lrcShow-II.conf', 'w'))
	
	def colorMenu_fore(self):
		rgbColor=QColorDialog.getColor(self.foreGroundColor)
		if(rgbColor.isValid()):
			self.foreGroundColor=rgbColor
			self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
			rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
			p=ConfigParser.ConfigParser()
			p.read('lrcShow-II.conf')
			p.set('option','fontcolor',rgbString)
			p.write(open('lrcShow-II.conf', 'w'))
	
	def colorMenu_light(self):
		rgbColor=QColorDialog.getColor(self.highLightColor)
		if(rgbColor.isValid()):
			self.highLightColor=rgbColor
			self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
			rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
			p=ConfigParser.ConfigParser()
			p.read('lrcShow-II.conf')
			p.set('option','highlightcolor',rgbString)
			p.write(open('lrcShow-II.conf', 'w'))
	
	def colorMenu_default(self):
		self.backGroundColor=QColor(57,64,98)
		self.foreGroundColor=QColor(255,255,255)
		self.highLightColor=QColor(180,200,255)
		self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
		p=ConfigParser.ConfigParser()
		p.read('lrcShow-II.conf')
		p.set('option','backroundcolor','57,64,98')
		p.set('option','fontcolor','255,255,255')
		p.set('option','highlightcolor','180,200,255')
		p.write(open('lrcShow-II.conf', 'w'))

	########## block end  ##########
	
	########## block: def setFontAction's fuction ##########
	
	def setFontAction_(self):
		font,ok=QFontDialog.getFont(QFont(self.fontType,self.fontSize),self)
		if ok:
			self.setFont(font)
			self.fontType=font.family()
			self.fontSize=font.pointSize()
			self.initMainEvent()
			self.goToCurrentPara()
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			l.set('option','fontsize',self.fontSize)
			l.set('option','fonttype',str(self.fontType.toUtf8()))
			l.write(open('lrcShow-II.conf', 'w'))
			if(self.showMode=='fullscreen'):
				self.displayMenu_normalAction_()
				self.displayMenu_fullscreenAction_()
	
	########## block end  ##########
	
	########## block: def setLineAction's fuction ##########
	
	def setLineAction_(self):
		num,ok=QInputDialog.getInteger(self,_(u'设置行数'),_(u'请输入1－19的奇数，否则无效'),self.lineNum,1,19,2)
		if(ok and num<>self.lineNum and num in range(1,21,2)):
			self.lineNum=num
			self.initMainEvent()
			self.goToCurrentPara()
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			l.set('option','linenumber',str(num))
			l.write(open('lrcShow-II.conf', 'w'))
			
	########## block end  ##########
	
	########## block: def setLocalPathAction's fuction ##########
	
	def setLocalPathAction_(self):
		app=addPathQt4(self)
		tmpPathList=map(lambda x:unicode(x,self.locale),self.path)
		for i in tmpPathList:
			app.insertItem(QTableWidgetItem(i,0))
		app.savePath.setText(unicode(self.saveLrcPath,self.locale))
		result=app.exec_()
		s1=''
		if(result==QDialog.Accepted):
			for j in range(0,app.rowNumber):
				s1+='%s,' %app.table.item(j,0).text().toUtf8()
			s2=app.savePath.text().toUtf8()
			self.path=map(lambda x:unicode(x,'utf8').encode(self.locale),s1.split(',')[0:-1])
			self.saveLrcPath=unicode(s2,'utf8').encode(self.locale)
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			l.set('option','lrcpath',s1)
			l.set('option','savelrcpath',s2)
			l.write(open('lrcShow-II.conf', 'w'))
		elif(result==QDialog.Rejected):
			pass
		
		
	
	########## block end  ##########
	
	########## block: def downloadMenu's fuction ##########
	
	def downloadMenu_yesAction_(self):
		if(self.ifDownload=='yes'):
			pass
		else:
			self.downloadMenu_yesAction.setIcon(QIcon('../scripts/lrcShow-II/icon/apply.png'))
			self.downloadMenu_noAction.setIcon(QIcon())
			self.ifDownload='yes'
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			l.set('option','download',self.ifDownload)
			l.write(open('lrcShow-II.conf', 'w'))
	
	def downloadMenu_noAction_(self):
		if(self.ifDownload=='no'):
			pass
		else:
			self.downloadMenu_noAction.setIcon(QIcon('../scripts/lrcShow-II/icon/apply.png'))
			self.downloadMenu_yesAction.setIcon(QIcon())
			self.ifDownload='no'
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			l.set('option','download',self.ifDownload)
			l.write(open('lrcShow-II.conf', 'w'))
	
	def downloadMenu_thisAction_(self):
		try:
			unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite)
		except UnicodeEncodeError:
			QMessageBox.critical(self,_(u'编码错误'),_(u'在将搜索到的歌词（%s）编码为您预设的保存编码（%s）时发生错误，此次下载被忽略！\n这一般是由于搜索到的歌词中含有无法编码的字符造成的。\n如果多次出现本对话框，强烈建议您关闭自动下载功能，另外也可以设置保存编码为gb18030或者utf8以避免这个问题。') %(self.netEncoder,self.encoderToWrite))
		else:
			if(os.path.exists(os.path.join(self.saveLrcPath,'%s - %s.lrc' %(self.artist,self.title)))):
				a=QMessageBox.question(self,_(u'询问'),_(u'同名文件已存在，是否覆盖？'),QMessageBox.Yes,QMessageBox.No)
				if(a==QMessageBox.Yes):
					file=open(os.path.join(self.saveLrcPath,'%s - %s.lrc' %(self.artist,self.title)),'w')
					file.write(unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite))
					file.close()
					self.originalLrc=None
					self.downloadMenu_thisAction.setEnabled(False)
					self.fileName=os.path.join(self.saveLrcPath,'%s - %s.lrc' %(self.artist,self.title))
					self.encoder=self.encoderToWrite
				else:
					pass
			else:
				file=open(os.path.join(self.saveLrcPath,'%s - %s.lrc' %(self.artist,self.title)),'w')
				file.write(unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite))
				file.close()
				self.originalLrc=None
				self.downloadMenu_thisAction.setEnabled(False)
				self.fileName=os.path.join(self.saveLrcPath,'%s - %s.lrc' %(self.artist,self.title))
				self.encoder=self.encoderToWrite
	##########  block end (need test) ##########
	
	##########  block: def displayMenu's function  ##########
	
	def displayMenu_normalAction_(self):
		if(self.showMode=='normal'):
			pass
		else:
			self.displayMenu_normalAction.setIcon(QIcon('../scripts/lrcShow-II/icon/apply.png'))
			if(self.showMode=='osd'):
				self.displayMenu_fullscreenAction.setEnabled(True)
				self.displayMenu_osdAction.setIcon(QIcon())
				self.setParent(None,Qt.Widget)
				self.setWindowIcon(QIcon('../scripts/lrcShow-II/icon/logo.png'))
				self.show()
			elif(self.showMode=='fullscreen'):
				self.displayMenu_osdAction.setEnabled(True)
				self.displayMenu_fullscreenAction.setIcon(QIcon())
				self.setLineAction.setEnabled(True)
				self.showNormal()
				l=ConfigParser.ConfigParser()
				l.read('lrcShow-II.conf')
				self.lineNum=int(l.get('option','linenumber'))
				self.initMainEvent()
				self.goToCurrentPara()
			self.showMode='normal'
	
	def displayMenu_fullscreenAction_(self):
		if(self.showMode=='fullscreen'):
			pass
		else:
			self.displayMenu_normalAction.setIcon(QIcon())
			self.displayMenu_fullscreenAction.setIcon(QIcon('../scripts/lrcShow-II/icon/apply.png'))
			self.displayMenu_osdAction.setEnabled(False)
			self.setLineAction.setEnabled(False)
			self.showFullScreen()
			self.lineNum=QApplication.desktop().height()/self.margin
			self.initMainEvent()
			self.goToCurrentPara()
			self.showMode='fullscreen'
	
	def displayMenu_osdAction_(self):
		if(self.showMode=='osd'):
			pass
		else:
			self.displayMenu_normalAction.setIcon(QIcon())
			self.displayMenu_osdAction.setIcon(QIcon('../scripts/lrcShow-II/icon/apply.png'))
			self.displayMenu_fullscreenAction.setEnabled(False)
			self.setParent(None,Qt.FramelessWindowHint|Qt.WindowStaysOnTopHint)
			self.setWindowIcon(QIcon('../scripts/lrcShow-II/icon/logo.png'))
			self.show()
			self.showMode='osd'
	
	###########  block end  ##########
	
	###########  block: def setProxyAction's function  ##########
	
	def setProxyAction_(self):
		l=ConfigParser.ConfigParser()
		l.read('lrcShow-II.conf')
		if(self.proxy):
			k,ok=QInputDialog.getText(self,_(u'代理设置'),_(u'请输入您要使用的Http代理，留空则表示不使用代理\n代理形式如http://www.xxx.yyy.com:80或者http://606.60.60.60:80'),QLineEdit.Normal,self.proxy['http'])
		else:
			k,ok=QInputDialog.getText(self,_(u'代理设置'),_(u'请输入您要使用的Http代理，留空则表示不使用代理\n代理形式如http://www.xxx.yyy.com:80或者http://606.60.60.60:80'),QLineEdit.Normal,u'')
		if(ok):
			if(str(k.toUtf8())==''):
				l.set('option','proxy','no')
				l.write(open('lrcShow-II.conf', 'w'))
				self.proxy=None
			else:
				l.set('option','proxy',str(k.toUtf8()))
				l.write(open('lrcShow-II.conf', 'w'))
				self.proxy={'http':str(k.toUtf8())}
	
	##########  block end  ##########
	
	########## block: def openLrcEditorAction's function ##########
	
	def openLrcEditorAction_(self):
		if(self.fileName):
			self.editBox=editBox(self.fileName,self.encoder)
		else:
			QMessageBox.information(self,_(u'提示'),_(u'没有找到本地歌词文件'))
			self.editBox=editBox(self.saveLrcPath,self.encoder)
		self.editBox.show()
	
	######## block end  ###########
	
	##########  block: def setSearchEngineAction's function  #########
	
	def setSearchEngineAction_(self):
		l=ConfigParser.ConfigParser()
		l.read('lrcShow-II.conf')
		strList=['baidu','sogou','ttPlayer']
		engineList=QStringList()
		for i in strList:
			engineList.append(i)
		index=strList.index(l.get('option','searchengine'))
		engine,ok=QInputDialog.getItem(self,_(u'设置搜索引擎'),_(u'请选择网络搜索引擎：'),engineList,index,False)
		if(ok):
			self.searchEngine=str(engine.toUtf8())
			l.set('option','searchengine',self.searchEngine)
			l.write(open('lrcShow-II.conf', 'w'))
	
	########## block end  ##########
	
	########## block: def otherFunctionsMenu's function ##########
	
	def otherFunctionsMenu_searchAction_(self):
		self.title=commands.getoutput('dcop amarok player title')
		self.artist=commands.getoutput('dcop amarok player artist')
		self.fileName=None  #maybe needn't
		self.originalLrc=None
		self.downloadMenu_thisAction.setEnabled(False)
		self.downLoad()
	
	def otherFunctionsMenu_reloadAction_(self):
		self.customEvent(myEvent('engineStateChange','playing'))
	
	def otherFunctionsMenu_cancelAction_(self):
		if(self.includeCancel=='yes'):
			d=False
		else:
			d=True
		self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II'+'</p>'),d)
	
	def otherFunctionsMenu_insertAction_(self):
		a=re.sub('<p align="center">','',self.mainContents)
		b=re.sub('</p>|<br>','\n',a)
		b=b.encode('utf8')
		lrc='<lyric title=\\"%s\\" artist=\\"%s\\" page_url=\\"http://mp3.baidu.com\\">%s</lyric>' %(self.title,self.artist,b)
		command='dcop amarok contextbrowser showLyrics "%s"' %lrc
		os.system(command)
		os.system('dcop amarok contextbrowser showLyrics')
	
	def otherFunctionsMenu_otherSetting_(self):
		settingDialog=otherSettingQt4(self)
		if(self.noLrc=='normal'):
			settingDialog.group_hide.normal.setChecked(True)
		elif(self.noLrc=='hide'):
			settingDialog.group_hide.hide.setChecked(True)
		else:
			settingDialog.group_hide.mini.setChecked(True)
		if(self.includeCancel=='yes'):
			settingDialog.group_hide.includeCheckBox.setChecked(True)
		if(self.autoInsertAmarok=='yes'):
			settingDialog.group_other.autoInsert.setChecked(True)
		if(self.titleBarInfo=='yes'):
			settingDialog.group_other.autoTitleBar.setChecked(True)
		if(self.completeTag=='yes'):
			settingDialog.group_other.completeTagSearch.setChecked(True)
		settingResult=settingDialog.exec_()
		if(settingResult==QDialog.Accepted):
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			if(settingDialog.group_hide.normal.isChecked()):
				self.noLrc='normal'
			elif(settingDialog.group_hide.hide.isChecked()):
				self.noLrc='hide'
			elif(settingDialog.group_hide.mini.isChecked()):
				self.noLrc='mini'
			l.set('option','nolrc',self.noLrc)
			if(settingDialog.group_hide.includeCheckBox.isChecked()):
				self.includeCancel='yes'
			else:
				self.includeCancel='no'
			l.set('option','includecancel',self.includeCancel)
			if(settingDialog.group_other.autoInsert.isChecked()):
				self.autoInsertAmarok='yes'
			else:
				self.autoInsertAmarok='no'
			l.set('option','autoinsert',self.autoInsertAmarok)
			if(settingDialog.group_other.autoTitleBar.isChecked()):
				self.titleBarInfo='yes'
			else:
				self.titleBarInfo='no'
			l.set('option','titlebarinfo',self.titleBarInfo)
			if(settingDialog.group_other.completeTagSearch.isChecked()):
				self.completeTag='yes'
			else:
				self.completeTag='no'
			l.set('option','completetag',self.completeTag)
			l.write(open('lrcShow-II.conf', 'w'))
		elif(settingResult==QDialog.Rejected):
			pass
		
	
	########## block end  ##########
	
	########## block: def setStrategyAction's function  #########
	
	def setStrategyAction_(self):
		data=self.myData.get('%s||%s' %(self.artist,self.title),False)
		if(data):
			self.relationDialog=hasRelationDialog(self)
			self.relationDialog.trackLabel.setText(unicode(self.artist,self.locale)+u' - '+unicode(self.title,self.locale))
			if(data=='FLAG.SKIP_SEARCHLOCAL'):
				content=_(u'不搜索本地')
			elif(data=='FLAG.SKIP_SEARCHENGINE'):
				content=_(u'不搜索网络')
			elif(data=='FLAG.SKIP_ALL'):
				content=_(u'什么都不做')
			else:
				content=unicode(data,self.locale)
			self.relationDialog.relationLabel.setText(content)
			result3=self.relationDialog.exec_()
			if(result3==1):
				del self.myData['%s||%s' %(self.artist,self.title)]
				mydb=open('lrcShow-II.db','w')
				pickler=pickle.Pickler(mydb,True)
				pickler.dump(self.myData)
				mydb.close()
			else:
				pass	
		else:
			self.relationDialog=hasNoRelationDialog(self)
			self.relationDialog.trackLabel.setText(unicode(self.artist,self.locale)+u' - '+unicode(self.title,self.locale))
			result3=self.relationDialog.exec_()
			if(result3==1):
				if(self.relationDialog.comboBox.currentIndex()==1):
					content='FLAG.SKIP_SEARCHLOCAL'
				elif(self.relationDialog.comboBox.currentIndex()==2):
					content='FLAG.SKIP_SEARCHENGINE'
				elif(self.relationDialog.comboBox.currentIndex()==3):
					content='FLAG.SKIP_ALL'
				elif(self.relationDialog.comboBox.currentIndex()==4):
					content=str(self.relationDialog.pathLine.text().toLocal8Bit())
				self.myData['%s||%s' %(self.artist,self.title)]=content
				mydb=open('lrcShow-II.db','w')
				pickler=pickle.Pickler(mydb,True)
				pickler.dump(self.myData)
				mydb.close()
			else:
				pass
	########## block end  ##########
	
	##########  block: def setSaveEncoderAction's function  #########
	
	def setSaveEncoderAction_(self):
		a=QMessageBox.question(self,_(u'询问'),_(u'该设置项将影响到下载lrc歌词（包括修改后的保存）时所用到的编码\n是否继续？'),QMessageBox.Yes,QMessageBox.No)
		if(a==QMessageBox.Yes):
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			strList=['latin1','big5','big5-hkscs','eucjp','shift-jis','iso 2022-jp-1','euc-jisx0213','euckr','gb2312','gbk','gb18030','utf8','utf16','koi8-r','koi8-u','iso 8859-1','iso 8859-2','iso 8859-3','iso 8859-4','iso 8859-5','iso 8859-6','iso 8859-7','iso 8859-8','iso 8859-9','iso 8859-10','iso 8859-13','iso 8859-14','iso 8859-15','ibm850','ibm866','cp874','cp1250','cp1251','cp1252','cp1253','cp1254','cp1255','cp1256','cp1257','cp1258','tis-620','mac roman']
			codecList=QStringList() 
			for i in strList:
				codecList.append(i)
			index=strList.index(l.get('option','encoder'))
			codec,ok=QInputDialog.getItem(self,_(u'设置保存歌词编码'),_(u'请选择lrc歌词的保存编码：'),codecList,index,False)
			if(ok):
				self.encoderToWrite=str(codec.toUtf8())
				l.set('option','encoder',self.encoderToWrite)
				l.write(open('lrcShow-II.conf', 'w'))
				
	##########  block end  ##########
	
	########## block: def viewHelpAction's function  #########
	
	def viewHelpAction_(self):
		helpBrowser=helpWindow(self)
		helpBrowser.show()
	
	######### block end  #########
	
	#########  block:def aboutAction's function  #########
	
	def aboutAction_(self):
		QMessageBox.about(self,_(u'关于lrcShow-II'),_(u'软件版本：lrcShow-II-0.7.0\n软件简介：动态显示lrc歌词的Amarok脚本\n软件作者：三翻领\n授权协议：GPL-v2.0\nBug提交：xujia19@gmail.com'))
		
	######### block end  #########
	
	def initMenu(self):
		self.myMenu=QMenu()
		
		self.lrcAdjustMenu=QMenu()
		self.lrcAdjustMenu.setTitle(_(u'调整偏移量'))
		self.lrcAdjustMenu.setIcon(QIcon('../scripts/lrcShow-II/icon/adjust.png'))
		self.lrcAdjustMenu_delayAction=QAction(QIcon('../scripts/lrcShow-II/icon/backward.png'),_(u'歌词滞后0.2秒'),self)
		self.lrcAdjustMenu_advancedAction=QAction(QIcon('../scripts/lrcShow-II/icon/forward.png'),_(u'歌词提前0.2秒'),self)
		self.lrcAdjustMenu_saveToFileAction=QAction(QIcon('../scripts/lrcShow-II/icon/save.png'),_(u'保存偏移量'),self)
		self.lrcAdjustMenu.addAction(self.lrcAdjustMenu_delayAction)
		self.lrcAdjustMenu.addAction(self.lrcAdjustMenu_advancedAction)
		self.lrcAdjustMenu.addAction(self.lrcAdjustMenu_saveToFileAction)
		self.myMenu.addMenu(self.lrcAdjustMenu)
		
		self.amarokControlMenu=QMenu()
		self.amarokControlMenu.setTitle(_(u'Amarok控制'))
		self.amarokControlMenu.setIcon(QIcon('../scripts/lrcShow-II/icon/amarok.png'))
		self.amarokControlMenu_playorpauseAction=QAction(QIcon('../scripts/lrcShow-II/icon/amarok_play.png'),_(u'播放'),self)
		self.amarokControlMenu_stopAction=QAction(QIcon('../scripts/lrcShow-II/icon/amarok_stop.png'),_(u'停止'),self)
		self.amarokControlMenu_prevAction=QAction(QIcon('../scripts/lrcShow-II/icon/amarok_back.png'),_(u'上一首'),self)
		self.amarokControlMenu_nextAction=QAction(QIcon('../scripts/lrcShow-II/icon/amarok_next.png'),_(u'下一首'),self)
		self.amarokControlMenu.addAction(self.amarokControlMenu_playorpauseAction)
		self.amarokControlMenu.addAction(self.amarokControlMenu_stopAction)
		self.amarokControlMenu.addAction(self.amarokControlMenu_prevAction)
		self.amarokControlMenu.addAction(self.amarokControlMenu_nextAction)
		self.myMenu.addMenu(self.amarokControlMenu)
		
		self.colorMenu=QMenu()
		self.colorMenu.setTitle(_(u'设置配色'))
		self.colorMenu.setIcon(QIcon('../scripts/lrcShow-II/icon/colors.png'))
		self.colorMenu_backAction=QAction(QIcon('../scripts/lrcShow-II/icon/background.png'),_(u'修改背景色...'),self)
		self.colorMenu_foreAction=QAction(QIcon('../scripts/lrcShow-II/icon/fontcolor.png'),_(u'修改字体色...'),self)
		self.colorMenu_lightAction=QAction(QIcon('../scripts/lrcShow-II/icon/highlight.png'),_(u'修改标亮色...'),self)
		self.colorMenu_defaultAction=QAction(QIcon('../scripts/lrcShow-II/icon/undo.png'),_(u'返回默认配色'),self)
		self.colorMenu.addAction(self.colorMenu_backAction)
		self.colorMenu.addAction(self.colorMenu_foreAction)
		self.colorMenu.addAction(self.colorMenu_lightAction)
		self.colorMenu.addAction(self.colorMenu_defaultAction)
		self.myMenu.addMenu(self.colorMenu)
		
		self.setFontAction=QAction(QIcon('../scripts/lrcShow-II/icon/font.png'),_(u'设置字体...'),self)
		self.myMenu.addAction(self.setFontAction)
		
		self.setLineAction=QAction(QIcon('../scripts/lrcShow-II/icon/line.png'),_(u'设置显示行数...'),self)
		self.myMenu.addAction(self.setLineAction)
		
		self.setLocalPathAction=QAction(QIcon('../scripts/lrcShow-II/icon/folder.png'),_(u'设置本地歌词路径...'),self)
		self.myMenu.addAction(self.setLocalPathAction)
		
		self.downloadMenu=QMenu()
		self.downloadMenu.setTitle(_(u'是否从网络下载'))
		self.downloadMenu.setIcon(QIcon('../scripts/lrcShow-II/icon/download.png'))
		self.downloadMenu_yesAction=QAction(_(u'是'),self)
		self.downloadMenu_noAction=QAction(_(u'否'),self)
		self.downloadMenu_thisAction=QAction(_(u'仅当前'),self)
		self.downloadMenu.addAction(self.downloadMenu_yesAction)
		self.downloadMenu.addAction(self.downloadMenu_noAction)
		self.downloadMenu.addAction(self.downloadMenu_thisAction)
		self.myMenu.addMenu(self.downloadMenu)
		
		self.displayMenu=QMenu()
		self.displayMenu.setTitle(_(u'设置显示模式'))
		self.displayMenu.setIcon(QIcon('../scripts/lrcShow-II/icon/screen.png'))
		self.displayMenu_normalAction=QAction(QIcon('../scripts/lrcShow-II/icon/apply.png'),_(u'普通模式'),self)
		self.displayMenu_fullscreenAction=QAction(_(u'全屏模式'),self)
		self.displayMenu_osdAction=QAction(_(u'OSD模式'),self)
		self.displayMenu.addAction(self.displayMenu_normalAction)
		self.displayMenu.addAction(self.displayMenu_fullscreenAction)
		self.displayMenu.addAction(self.displayMenu_osdAction)
		self.myMenu.addMenu(self.displayMenu)
		
		self.setProxyAction=QAction(QIcon('../scripts/lrcShow-II/icon/proxy.png'),_(u'设置网络代理...'),self)
		self.myMenu.addAction(self.setProxyAction)
		
		self.openLrcEditorAction=QAction(QIcon('../scripts/lrcShow-II/icon/edit.png'),_(u'歌词编辑器...'),self)
		self.myMenu.addAction(self.openLrcEditorAction)
		
		self.setSearchEngineAction=QAction(QIcon('../scripts/lrcShow-II/icon/engine.png'),_(u'设置搜索引擎...'),self)
		self.myMenu.addAction(self.setSearchEngineAction)
		
		self.otherFunctionsMenu=QMenu()
		self.otherFunctionsMenu.setTitle(_(u'其他功能'))
		self.otherFunctionsMenu.setIcon(QIcon('../scripts/lrcShow-II/icon/function.png'))
		self.otherFunctionsMenu_searchAction=QAction(QIcon('../scripts/lrcShow-II/icon/search.png'),_(u'从网络搜索歌词'),self)
		self.otherFunctionsMenu_cancelAction=QAction(QIcon('../scripts/lrcShow-II/icon/cancel.png'),_(u'撤销当前歌词'),self)
		self.otherFunctionsMenu_reloadAction=QAction(QIcon('../scripts/lrcShow-II/icon/reload.png'),_(u'重新载入歌词'),self)
		self.otherFunctionsMenu.addAction(self.otherFunctionsMenu_reloadAction)
		self.otherFunctionsMenu.addAction(self.otherFunctionsMenu_cancelAction)
		self.otherFunctionsMenu_insertAction=QAction(QIcon('../scripts/lrcShow-II/icon/add_lyrics.png'),_(u'传送歌词至Amarok侧边栏'),self)
		self.otherFunctionsMenu_otherSetting=QAction(QIcon('../scripts/lrcShow-II/icon/configure.png'),_(u'其它设置...'),self)
		self.otherFunctionsMenu.addAction(self.otherFunctionsMenu_searchAction)
		self.otherFunctionsMenu.addAction(self.otherFunctionsMenu_otherSetting)
		self.otherFunctionsMenu.addAction(self.otherFunctionsMenu_insertAction)
		self.myMenu.addMenu(self.otherFunctionsMenu)
		
		self.setStrategyAction=QAction(QIcon('../scripts/lrcShow-II/icon/relation.png'),_(u'当前音轨歌词策略...'),self)
		self.myMenu.addAction(self.setStrategyAction)
		
		self.setSaveEncoderAction=QAction(QIcon('../scripts/lrcShow-II/icon/locale.png'),_(u'设置保存歌词编码...'),self)
		self.myMenu.addAction(self.setSaveEncoderAction)
		
		self.viewHelpAction=QAction(QIcon('../scripts/lrcShow-II/icon/help.png'),_(u'查看帮助...'),self)
		self.myMenu.addAction(self.viewHelpAction)
		
		self.aboutAction=QAction(QIcon('../scripts/lrcShow-II/icon/logo.png'),_(u'关于lrcShow-II...'),self)
		self.myMenu.addAction(self.aboutAction)
		
		self.closeAction=QAction(QIcon('../scripts/lrcShow-II/icon/exit.png'),_(u'退出lrcShow-II'),self)
		self.myMenu.addAction(self.closeAction)
	
	def initSettingMenuBar(self):
		self.toolMenuBar=QToolBar(self)
		self.toolMenuBar.addAction(self.lrcAdjustMenu_delayAction)
		self.toolMenuBar.addAction(self.lrcAdjustMenu_advancedAction)
		self.toolMenuBar.addAction(self.lrcAdjustMenu_saveToFileAction)
		self.toolMenuBar.addSeparator()
		self.toolMenuBar.addAction(self.amarokControlMenu_playorpauseAction)
		self.toolMenuBar.addAction(self.amarokControlMenu_stopAction)
		self.toolMenuBar.addAction(self.amarokControlMenu_prevAction)
		self.toolMenuBar.addAction(self.amarokControlMenu_nextAction)
		self.toolMenuBar.addSeparator()
		self.toolMenuBar.addAction(self.openLrcEditorAction)
		self.toolMenuBar.hide()
	
	def initColor(self,a,b,c):
		pl=QPalette()
		for i in [QPalette.Active,QPalette.Inactive,QPalette.Disabled]:
			for j in [QPalette.Window,QPalette.Base]:
				pl.setColor(i,j,a)
			pl.setColor(i,QPalette.Text,b)
			pl.setColor(i,QPalette.Highlight,a)
			pl.setColor(i,QPalette.HighlightedText,c)
		self.setPalette(pl)
			
	def contextMenuEvent(self,ev):
		self.myMenu.popup(ev.globalPos())

	def mouseDoubleClickEvent(self,ev):
		if(self.toolMenuBar.isHidden()):
			self.toolMenuBar.show()
		else:
			self.toolMenuBar.hide()
	
	#def paintEvent(self,ev):
		#pass
	
	############# define shortcut  #########################
	def keyPressEvent(self,ev):
		if(ev.key()==Qt.Key_Minus and self.lrcAdjustMenu_delayAction.isEnabled()):
			self.seekSlow()
		elif(ev.key()==Qt.Key_Plus and self.lrcAdjustMenu_advancedAction.isEnabled()):
			self.seekFast()
		elif(ev.key()==Qt.Key_S and self.lrcAdjustMenu_saveToFileAction.isEnabled()):
			self.saveToFile()
		elif(ev.key()==Qt.Key_F and self.showMode=='normal'):
			self.displayMenu_fullscreenAction_()
		elif(ev.key()==Qt.Key_Escape and (self.showMode=='fullscreen' or self.showMode=='osd')):
			self.displayMenu_normalAction_()
		elif(ev.key()==Qt.Key_O and self.showMode=='normal'):
			self.displayMenu_osdAction_()
		elif(ev.key()==Qt.Key_E):
			self.openLrcEditorAction_()
	
	def mouseReleaseEvent(self,ev):
		pass
	
	def wheelEvent(self,ev):
		pass
	
	def dragMoveEvent(self,ev):
		pass
	
	def mousePressEvent(self,ev):
		self.xPos=ev.x()
		self.yPos=ev.y()
	def mouseMoveEvent(self,ev):
		if(self.showMode=='fullscreen'):
			pass
		else:
			if(ev.buttons()==Qt.LeftButton):
				a=ev.x()-self.xPos
				b=ev.y()-self.yPos
				self.move(self.x()+a,self.y()+b)
			
class editBox(QWidget):
	
	def __init__(self,f,e,*args):
		apply(QWidget.__init__,(self,)+args)
		self.setWindowIcon(QIcon('../scripts/lrcShow-II/icon/logo.png'))
		self.setWindowTitle(_(u'lrcShow-II歌词编辑器'))
		self.setMinimumSize(QSize(500,280))
		layout = QVBoxLayout(self)
		self.menuArea=menuArea(self)
		self.editArea=editArea(self)
		self.editArea.setFocus()
		layout.addWidget(self.menuArea)
		layout.addWidget(self.editArea)
		self.fileName=f
		self.encoder=e
		if(os.path.isfile(self.fileName)):
			self.editArea.showText(self.fileName,self.encoder)
		else:
			self.editArea.setText(_(u'[ti:]\n[ar:]\n[al:]\n[by:]'))
		self.connect(self.menuArea.save,SIGNAL("clicked()"),self.save)
		self.connect(self.menuArea.saveAs,SIGNAL("clicked()"),self.saveAs)
		self.connect(self.editArea,SIGNAL("textChanged()"),self.saveEnabled)
		self.connect(self.menuArea.clearTag,SIGNAL("clicked()"),self.clearTag)
		self.connect(self.menuArea.insertTag,SIGNAL("clicked()"),self.insertTag)
		self.connect(self.menuArea.transferButton,SIGNAL("clicked()"),self.charaTransfer)
	
	def saveEnabled(self):
		if(os.path.isfile(self.fileName)):
			self.menuArea.save.setEnabled(True)
		else:
			pass	
	def save(self):
		content=str(self.editArea.toPlainText().toUtf8())
		content=unicode(content,'utf8').encode(self.encoder)
		file=open(self.fileName,'w')
		file.write(content)
		file.close()
		self.menuArea.save.setEnabled(False)
	
	def saveAs(self):
		filename=QFileDialog.getSaveFileName(self,_(u'另存为'),self.fileName.decode(getdefaultlocale()[1]),'*.txt *.lrc')
		if(str(filename.toUtf8())<>''):
			content=str(self.editArea.toPlainText().toUtf8())
			content=unicode(content,'utf8').encode(self.encoder)
        		file=open(str(filename.toLocal8Bit()),'w')
        		file.write(content)
        		file.close()
        	else:
        		pass
	
	def charaTransfer(self):
		p=s2t.s2t(str(self.editArea.toPlainText().toUtf8()))
		content=p.transfer()
		self.editArea.clear()
		self.editArea.setText(content.decode('utf8'))
	
	def clearTag(self):
		content=str(self.editArea.toPlainText().toUtf8())
		self.editArea.clear()
		content=re.sub('\[\d\d:\d\d.*?\]','',content)
		self.editArea.setText(content.decode('utf8'))
	
	def insertTag(self):
		currentTime=int(commands.getoutput('dcop amarok player trackCurrentTimeMs'))
		munites,ms=divmod(currentTime,60000)
        	if(len(str(ms))==3):
			seconds='00'
		elif(len(str(ms))==4):
                	seconds='0'+str(ms)[0]
        	else:
                	seconds=str(ms)[0:2]
        	mseconds=str(ms)[-3:-1]
        	munites=str(munites)
        	if(len(munites)<>2):
                	munites='0'+munites
        	currentTag='[%s:%s.%s]' %(munites,seconds,mseconds)
		self.editArea.textCursor().insertText(currentTag)
        	self.editArea.moveCursor(QTextCursor.StartOfLine)
        	self.editArea.moveCursor(QTextCursor.Down)

class menuArea(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,)+args)
		self.setMinimumHeight(30)
		
		self.save=QPushButton(self)
		self.save.setGeometry(QRect(5,0,70,30))
		self.save.setText(_(u'快速保存'))
		self.save.setEnabled(False)
		
		self.saveAs=QPushButton(self)
		self.saveAs.setGeometry(QRect(80,0,70,30))
		self.saveAs.setText(_(u'另存为...'))
		
		self.transferButton=QPushButton(self)
		self.transferButton.setGeometry(QRect(155,0,70,30))
		self.transferButton.setText(_(u'简繁转换'))
		
		self.clearTag=QPushButton(self)
		self.clearTag.setGeometry(QRect(230,0,120,30))
		self.clearTag.setText(_(u'清空时间标签'))
		
		self.insertTag=QPushButton(self)
		self.insertTag.setGeometry(QRect(355,0,120,30))
		self.insertTag.setText(_(u'插入时间标签(F5)'))
		self.insertTag.setShortcut(QKeySequence(Qt.Key_F5))
		
class editArea(QTextEdit):
	
	def __init__(self,*args):
		apply(QTextEdit.__init__,(self,)+args)
	
	def showText(self,f,e):
		file=open(f)
		content=unicode(file.read(),e)
		file.close()
		self.setText(content)