#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: otherSettingQt3.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from qt import *
import sys,os

class otherSettingQt3(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		self.setCaption(_(u'其它设置'))
		MainWindowLayout=QVBoxLayout(self,10,10)
		
		layout1=QHBoxLayout(None,0,10)
		self.group_hide=group_hide(self)
		self.group_other=group_other(self)
		layout1.addWidget(self.group_hide)
		layout1.addWidget(self.group_other)
		
		layout2=QHBoxLayout(None,10,130)
		self.okButton=QPushButton(self)
		self.okButton.setText(_(u'确定'))
		
		self.cancelButton=QPushButton(self)
		self.cancelButton.setText(_(u'取消'))
		layout2.addWidget(self.okButton)
		layout2.addWidget(self.cancelButton)
		
		MainWindowLayout.addLayout(layout1)
		MainWindowLayout.addLayout(layout2)
		
		self.connect(self.okButton,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancelButton,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.group_hide.normal,SIGNAL("toggled(bool)"),self.normalChecked)
	
	def normalChecked(self,checked):
		if(checked):
			self.group_hide.includeCheckBox.setEnabled(False)
		else:
			self.group_hide.includeCheckBox.setEnabled(True)


class group_hide(QButtonGroup):
	
	def __init__(self,*args):
        	apply(QButtonGroup.__init__,(self,) + args)
		self.setTitle(_(u'无歌词时窗口行为'))
		mainLayout=QVBoxLayout(self,15,5)
		mainLayout.addSpacing(10)
		
		self.normal=QRadioButton(_(u'窗口无变化'),self)
		self.hide=QRadioButton(_(u'窗口自动隐藏'),self)
		self.mini=QRadioButton(_(u'窗口自动最小化'),self)
		self.includeCheckBox=QCheckBox(self)
		self.includeCheckBox.setText(_(u'包括撤销歌词'))
		
		mainLayout.addWidget(self.normal)
		mainLayout.addWidget(self.hide)
		mainLayout.addWidget(self.mini)
		mainLayout.addWidget(self.includeCheckBox)


class group_other(QGroupBox):
	
	def __init__(self,*args):
        	apply(QGroupBox.__init__,(self,) + args)
		self.setTitle(_(u'其它选项'))
		mainLayout=QVBoxLayout(self,15,5)
		mainLayout.addSpacing(10)
		
		self.autoInsert=QCheckBox(self)
		self.autoInsert.setText(_(u'自动插入歌词至Amarok侧边栏'))
		QToolTip.add(self.autoInsert,_(u'开启此功能，强烈建议您关闭其它Amarok歌词脚本'))
		self.completeTagSearch=QCheckBox(self)
		self.completeTagSearch.setText(_(u'仅标签完整时搜索歌词'))
		QToolTip.add(self.completeTagSearch,_(u'无标签信息时强制不搜索'))
		self.autoTitleBar=QCheckBox(self)
		self.autoTitleBar.setText(_(u'标题栏显示音轨信息'))
		QToolTip.add(self.autoTitleBar,_(u'改变此选项后，下个音轨生效；不包括无标签信息的音轨'))
		
		mainLayout.addWidget(self.autoTitleBar)
		mainLayout.addWidget(self.completeTagSearch)
		mainLayout.addWidget(self.autoInsert)





def main(args):
	app=QApplication(args)
	win=otherSettingQt3()
	win.show()
	app.connect(app, SIGNAL("lastWindowClosed()"),app, SLOT("quit()"))
	app.exec_loop()

if(__name__=="__main__"):
	main(sys.argv)